#include "dxstdafx.h"
#include "./SkyBox.h"

SkyBox::SkyBox(void):Node() {
	this->nodeType |= SoftShadowScene::NODE_SKYBOX;
}

void SkyBox::generateSkyBox(std::string filename)
{
	//generate Object3d for Skybox and add it to the scene
	Object3d *p = (Object3d *) this->myScene->createNode(this->myScene->NODE_OBJECT3D, *this->myScene->getRoot(), true);
	this->myBox = p;

	//create renderer
	SPTR<Renderer> renderer(new SkyBoxRenderer);
	renderer->setScene(*this->myScene);
	this->myScene->connectNodeAndRenderer(*p, renderer);
	
	p->loadMeshFromFile(filename);
}

SkyBox::~SkyBox(void)
{
}

Object3d* SkyBox::getBoxObject() {
	return this->myBox;
}