#pragma once
#include <vector> // Standard-Vektor einschlieen
#include <string>
#include <fstream>
#include "./GameManager.h"
#include "./Object3d.h"
#include <boost/shared_ptr.hpp>
#include <new>
#include <exception>
#include "Node.h"

using namespace std;

#define SPTR boost::shared_ptr

/**
SkyBox class
*/

class SkyBox : public Node
{
public:
	/**
	Constructor for SkyBox object
	*/
	SkyBox(void);
	/**
	Destructor for SkyBox object
	*/
	~SkyBox(void);
	/**
	Generate Sky Box
	*/
	void generateSkyBox(std::string filename);
	/**
	Returns the Object3d of the sky box
	*/
	Object3d* getBoxObject();
private:
	Object3d * myBox;
};
