#pragma once
#include "renderer.h"

/**
SoftShadowLightRenderer class
*/

class SoftShadowLightRenderer :
	public Renderer
{
public:
	/**
	Constructor for SoftShadowLightRenderer object
	*/
	SoftShadowLightRenderer(void);
	/**
	Destructor for SoftShadowLightRenderer object
	*/
	~SoftShadowLightRenderer(void);

	virtual void render();
	virtual void init();
	virtual bool isLowerThan(Renderer* renderer);

	virtual void OnLostDevice( void* pUserContext );
	virtual void OnDestroyDevice( void* pUserContext );
	virtual HRESULT OnResetDevice( IDirect3DDevice9* pd3dDevice, const D3DSURFACE_DESC* pBackBufferSurfaceDesc, void* pUserContext );

protected:
	static const DWORD vertexFVF = (D3DFVF_XYZ | D3DFVF_DIFFUSE);

	struct CUSTOMVERTEX
	{
		float x,y,z;
		D3DCOLOR emissive;
	};

	IDirect3DVertexBuffer9* lightLine;
};
