#pragma once
#include "Node.h"
#include "Vector.h"

#define SPTR boost::shared_ptr

class Trigger
{
public:
	Trigger(void);
	Trigger(int _type, float time);
	Trigger(int _type, float time, std::string _text);
	Trigger(int _type, SPTR<Node> _node, float time);
	Trigger(int _type, SPTR<Node> _node, SPTR<Node> _secondNode, float _time);
	Trigger(int _type, SPTR<Node> _node, SPTR<Node> _secondNode, Vector _normal, float _time);
	~Trigger(void);

	void setType(int _type);
	int getType();

	void setNode(SPTR<Node> _node);
	SPTR<Node> getNode();
	void setSecondNode(SPTR<Node> _node);
	SPTR<Node> getSecondNode();

	void setTime(float _time);
	float getTime();

	void setNormal(Vector _normal);
	Vector getNormal();
protected:
	int type;
	SPTR<Node> node;
	SPTR<Node> secondNode;
	Vector normal;
	float time;
	std::string text;
};
